︠af9e370a-b28a-4e92-ae57-720902ded152s︠
import numpy
import itertools
import math

def TonSh (a, Prime):
    if kronecker(a, Prime) == -1:
        pass
        print "{0} does not have a square root mod {1}".format(a, Prime)
        return None
    elif Prime % 4 == 3:
        x = power_mod(ZZ(a), ZZ((Prime+1)/4),ZZ(Prime))
        return(x)
    else:
        #################################################################################
        # Determine e so that Prime-1 = (2^e)*q for some odd number q                   # 
        #################################################################################

        e = ZZ(0)
        q = ZZ(Prime - 1)
#       for j in range(1, Prime):
        for j in itertools.count(1):
            if q % 2 == 0:
                e = ZZ(e + 1)
                q = ZZ(q / 2)
            else:
                break
        for i in range(1, 101):
            n = i
            if kronecker(n, Prime) == -1:
                break
        z = power_mod(ZZ(n),ZZ(q),ZZ(Prime))
        y = ZZ(z)
        r = ZZ(e)
        x = power_mod(ZZ(a),ZZ( (q-1)/2),ZZ( Prime))
        b = (a * x ** 2) % Prime
        x = (a * x) % Prime
        #for i in range(1, e + 1):
        for i in itertools.count(1):
            if b == 1:
                break
            else:
                for m in itertools.count(1):
                    t = power_mod(ZZ(b), ZZ(2^m) ,  ZZ(Prime))
                    if t == 1:
                        mm = m
                        break
                t = power_mod(ZZ(y), ZZ(2^(r - mm - 1)),ZZ(Prime))
                y = power_mod(ZZ(t), ZZ(2),ZZ(Prime))
                r = mm
                x = (x * t) % Prime
                b = (b * y) % Prime
        return(x)



def listproduct (primelist):
    x = primelist
    k = len(primelist)
    #print x
    result = 1
    for i in range(0, k):
        result = result * x[i][0] ^ x[i][1] #op(1, op(i, x)) ** op(2, op(i, x))
    return(result)

def listptorder (pt, Group, factoredGpOrder):
    ECIdentity = []
    x = factoredGpOrder
    k = len(factoredGpOrder)
    orderlist = []#set([])
    result = listproduct(factoredGpOrder)
    for i in range(0, k ):
        p =  x[i][0] #op(1, op(i, x))
        a =  x[i][1] #op(2, op(i, x))
        ord = 0
        for j in range(0, a ):
            try:
                #print result / p
                result = ZZ(result / p)
                test = ECTimes(pt, result, Group)
                if test != ECIdentity:
                    result = result * p
                    ord = ord + 1
            except:
                pass
        if 0 < ord:
            orderlist.append([p,ord])
    #print orderlist
    returnlist = []
    return orderlist#(convert(orderlist, list))

def primeHPSonEC (y,g,Group,p):
    newg = []
    #for j in range(0, p ):
    for j in itertools.count(0):
        if y == newg:
            break
        #print (newg,g)
        newg = ECAdd(newg, g, Group)
    return(j)


def powerHPSonEC (y,g,og,p,a,Group):
    gp = ECTimes(g, ZZ(og / p), Group)
    newog = og
    newy = y
    c = 0
    partx = 0
    for i in range(0, a ):
        #print (y, ECInverse(ECTimes(g, partx, Group), Group))
        newy = ECAdd(y, ECInverse(ECTimes(g, partx, Group), Group), Group)
        newog = ZZ(newog / p)
        ypower = ECTimes(newy, newog, Group)
        c = primeHPSonEC(ypower, gp, Group, p)
        partx = partx + c * p ** i
    return(partx)

def HPSonEC (y,g,Group,factoredGpOrder):
    X = 0
    Ord = 1
    K = listptorder(g, Group, factoredGpOrder)
    k = len(K)
    ordg = listproduct(K)
    #print K
    for j in range(0, k):
        #print (K,j)
        p = K[j][0] #op(1, op(j, K))
        powerp = K[j][1] #op(2, op(j, K))
        #print powerp
        partx = powerHPSonEC(y, g, ordg, p, powerp, Group)
        #print partx
        if j == 0:
            X = partx
            Ord = p ** powerp
            #print "firstif"
            #print X
            #print Ord
        else:
            #print [X,partx]
            #print [Ord,p^powerp]
            X = crt([X,partx], [Ord,p ^ powerp])
            Ord = Ord * (p ^ powerp)
        #print X
    return(X)
def findptOrder(point,group):
    E = EllipticCurve(GF(group[2]),[group[0],group[1]])
    Ep = E(point[0],point[1])
    return Ep.additive_order()
def ECTimes (Point, scalar, Group):
    ECIdentity=[]
    if Point == ECIdentity or scalar == 0:
        return(ECIdentity)
    else:
        E=EllipticCurve(GF(Group[2]),[Group[0],Group[1]])
        EPoint = E(Point[0],Point[1])
        #print type(EPoint)
        cgret = scalar*EPoint
        #print cgret[0]
        if(cgret[0]==0 and cgret[1]==1 and cgret[2]==0):
            return ECIdentity
        return([cgret[0],cgret[1]])
def ECInverse (Point, Group):
    if Point == []:
        return(Point)
    else:
        p = Group[2]
        x = Point[0]
        y = Point[1]
        return([x,(p - y) % p])
def ECDouble (Point, Group):
    a = Group[0]
    b = Group[1]
    p = Group[2]
    if Point != []:
        x1 = Point[0]
        y1 = Point[1]
        if (4 * a ** 3 + 27 * b ** 2) % p == 0:
            print "This is not an elliptic curve. "
        elif Point != [] and y1 ** 2 % p != (x1 ** 3 + a * x1 + b) % p:
            print "The point to double is not on the elliptic curve. "
        elif y1 == 0:
            R = []
        else:
            s = mod((3 * x1 ** 2 + a) / y1 / 2, p)
            x = (s ** 2 - 2 * x1) % p
            y = (s * (x1 - x) - y1) % p
            R = [x,y]
    else:
        R = []
    return(R)
def ECAdd (Point1, Point2, Group):
    a = Group[0]
    b = Group[1]
    p = Group[2]
    if(Point1!=[]):
        x1 = Point1[0]
        y1 = Point1[1]
    if(Point2!=[]):
        x2 = Point2[0]
        y2 = Point2[1]
    if (4 * a ** 3 + 27 * b ** 2) % p == 0:
        print "This is not an elliptic curve. "
    elif Point1 != [] and y1 ** 2 % p != (x1 ** 3 + a * x1 + b) % p:
        print "Point 1 is not on the elliptic curve. \n"
    elif Point2 != [] and y2 ** 2 % p != (x2 ** 3 + a * x2 + b) % p:
        print "Point 2 is not on the elliptic curve. \n"
    else:
        if Point1 == []:
            R = Point2
        elif Point2 == []:
            R = Point1
        else:
            if x1 == x2 and 0 == (y1 + y2) % p:
                R = []
            elif x1 == x2 and y1 == y2:
                R = ECDouble(Point1, Group)
            else:
                s = ((y1 - y2) / (x1 - x2)) % p
                x = (s ** 2 - x1 - x2) % p
                y = (s * (x1 - x) - y1) % p
                R = [x,y]
    return(R)
def ASCIIPad(Mess,Mod):
    K = []
    for letter in Mess:
        K.append(ord(letter))
    L = Mod.ndigits()
    l = len(K)
    y = ZZ(math.floor(L/3))
    count = 0
    padded = []
    buffer = ""
    for numChar in K:
        numChar+=100
        buffer+=str(numChar)
        count+=1
        if count==y:
            padded.append(ZZ(buffer))
            buffer = ""
            count = 0
    if len(buffer)>0:
        padded.append(ZZ(buffer))
    return padded

                
def ASCIIDepad(Number):
    N = "";
    #Number = ZZ(Number[0])
    n = Number.ndigits() % 3;
    if (n > 0):
        print("This is not a padded ASCII string\n");
    else:
        L = [((Number - (Number % (1000^i)))/1000^i)%1000 - 100 for i in range(Number.ndigits()/3)];
        for i in range(Number.ndigits()/3):
            #print L[i]
            N = chr(L[i]) + N;
            
    return(N);

def ECEmbed (Message, gp, tolerance):
    p = ZZ(math.floor(gp[2] / (tolerance + 1)))
    M = ASCIIPad(Message, p)
    packets = len(M)
    #print packets
    pointlist = [0]*packets
    for j in range(0, packets ):
        N = M[j]
#        N:=(op(0,op(1,M))[j]);
        pointlist[j] = ECSearch(tolerance * N, tolerance * (N + 1) - 1, gp)
        #print pointlist
    return(pointlist)

def ECUnembed (pointlist, tolerance):
    #print pointlist
    k = len(pointlist)
    paddedasciilist=[0]*k
    for j in range(0, k ):
        #print type(pointlist[j][0]/tolerance)
        #print pointlist
        #print paddedasciilist        
        #print "test this "+str((pointlist[j][0]/tolerance))
        #.floor() returns correct while math.floor() does not work
        #print (pointlist[j][0])
        pointlist[j][0]=ZZ(pointlist[j][0])
        toType = ZZ(QQ((pointlist[j][0])/tolerance).floor())
#        typed = type(toType)
#        print typed
        paddedasciilist[j] = ((pointlist[j][0])/tolerance).floor()
    returnStr = ""
    for paddedItem in paddedasciilist:
        #print paddedItem
        buffer = ASCIIDepad(paddedItem)
        returnStr+= buffer
        #print buffer
    return returnStr

︡cb17fb96-bb6f-4ed1-a619-b428952c197b︡{"done":true}︡
︠0a040cfc-942e-4399-8f09-3fee766a8a9fs︠
#Encryption Group is:
A_Encryption = 32423423
B_Encryption = 0
P_Encryption = 111111756372541867431527
G_Encryption = [32423423, 0, 111111756372541867431527]
#Public Encryption point b:
Apb_Encryption = [77012625572753817011635, 107177820655281658062820]
Bpb_Encryption = [63567155336615021877739, 36007178347937208049611]
Cpb_Encryption = [104225718616102818923406, 48710727653703914714853]
#Base point g for encryption is:
gpoint_Encryption = [133213, 42904742913851518927444]
#Notice that B=0. So if p mod 4 is 3, then the 
P_Encryption % 4
︡894cce9a-ccc5-446e-857d-eb0e3a6ba45d︡{"stdout":"3\n"}︡{"done":true}︡
︠820415db-37c4-4642-85a1-75fee81ec72fs︠
#So the size of our group is going to be p+1
gorder_Encryption=P_Encryption+1
factor(gorder_Encryption)
︡3bc48da9-0a80-4f83-aaf3-2303750ca1dd︡{"stdout":"2^3 * 3^2 * 13 * 17 * 89 * 211 * 839 * 466637 * 949777\n"}︡{"done":true}︡
︠f952cc24-2036-44cc-a9fb-8cabc2fdfa62s︠
#So this group is likely vulnerable to HPS
#Recall that each secret key is x such that b=g^x=ECTimes(g,x,G)
#Let's write down what we need to use to find x_A
#x_a=HPSonEC(bA,g,G,factorization)
x_a=HPSonEC(Apb_Encryption,gpoint_Encryption,G_Encryption,[[2,3],[3,2],[13,1],[17,1],[89,1],[211,1],[839,1],[466637,1],[949777,1]])
x_a

︡d467207a-a684-42d9-b392-cc4c61897248︡{"stdout":"432123\n"}︡{"done":true}︡
︠51c67065-60da-47cc-a2b7-8d4d02d03b81s︠
x_a=432123
ECTimes(gpoint_Encryption,x_a,G_Encryption)
︡e83fcc3a-ef37-49b9-bf5b-b00368219cc1︡{"stdout":"[77012625572753817011635, 107177820655281658062820]\n"}︡{"done":true}︡
︠54898be8-8334-4aa5-9e7e-9b41dcb05cbds︠
#x_a=432123
x_b=HPSonEC(Bpb_Encryption,gpoint_Encryption,G_Encryption,[[2,3],[3,2],[13,1],[17,1],[89,1],[211,1],[839,1],[466637,1],[949777,1]])
x_b

︡e657953d-deed-44fc-bfd9-ec0b31753c19︡{"stdout":"675348\n"}︡{"done":true}︡
︠1d771ead-a079-40ef-ade7-c19a9df11ed1s︠
#x_b=675348
x_c=HPSonEC(Cpb_Encryption,gpoint_Encryption,G_Encryption,[[2,3],[3,2],[13,1],[17,1],[89,1],[211,1],[839,1],[466637,1],[949777,1]])
x_c
︡13d8c81f-dbc1-4945-a6de-da1913882daf︡{"stdout":"876549\n"}︡{"done":true}︡
︠12c2c1f3-ac53-4a90-a681-1f7394f02beds︠
#signature group: G_s=[0,B,p]
#so let's check to see if p mod 3=2
#It is!
#now we factor(p+1)=2*3^5*51*620176035713316419537
#Also note that they all use the same base point g
#factor(order(g))
#but g is prime! It is the big prime from before! Yay!
#Cauchy's Theorem
#If (G,^) is any finite group, and g \in G, then order(g) divides into |G|
#signature b from Alice=sbA, etc
#again, 
︡c6818afd-1bfa-40c1-8e0b-f585eaf2c49c︡{"done":true}︡
︠4f097a3f-8d1c-4cb8-90c8-af9b6eec73eas︠

#
A_Signature = 0
B_Signature = 98766778
P_Signature = 12357627687623542975694261
G_Signature = [0, 98766778, 12357627687623542975694261]
#
Apb_Signature = [5246859784562186496635824, 5457612259949488195005309]
Bpb_Signature = [5278780115068892215096216, 6857888556017625502158912]
Cpb_Signature = [11500587084934239979269346, 4630177618473717713077113]
#
T=45
gpoint_Signature = [2539662136869871783297850, 1414894921445613162605806]
gorder_Signature = 620176035713316419537
#
M_Signature = [522228913141586484647, 496418275430782450147]
y=522228913141586484647
s=496418275430782450147
M1 = [64822910729849959453845, 54324913307643112006572]
M2 = [40965317570056334177487, 76589794174623293315486]
#
#Check that p mod 3 = 2
P_Signature % 3
︡8b87037d-6d35-4739-a119-6342cc41a295︡{"stdout":"2\n"}︡{"done":true}︡
︠ada5eba4-a7df-42a1-b762-4bf3ce446c08s︠
#It is! So the order of G is p+1
factor(P_Signature+1)
︡50040305-a4e7-4b9c-a4f3-f6d7dd377f80︡{"stdout":"2 * 3^5 * 41 * 620176035713316419537\n"}︡{"done":true}︡
︠086d7a65-6f11-4d92-a468-3cfa71fffa1ds︠
#Now for the signatures
sx_a=HPSonEC(Apb_Signature,gpoint_Signature,G_Signature,[[2,1],[3,5],[41,1],[620176035713316419537,1]])
sx_a
︡2fea4b95-9644-4d78-a545-ec7c96b64ef0︡{"stdout":"897672\n"}︡{"done":true}︡
︠6da11a8e-3162-46f2-b2b3-800899794d46s︠
sx_b=HPSonEC(Bpb_Signature,gpoint_Signature,G_Signature,[[2,1],[3,5],[41,1],[620176035713316419537,1]])
sx_b
︡b99786a6-384d-4137-9a85-bc6faeade531︡{"stdout":"213543\n"}︡{"done":true}︡
︠e0f89e28-6186-4177-9632-97b66b05e1a9s︠
sx_c=HPSonEC(Cpb_Signature,gpoint_Signature,G_Signature,[[2,1],[3,5],[41,1],[620176035713316419537,1]])
sx_c
︡d80708fa-9df2-4935-933f-ac638493fb7c︡{"stdout":"432198\n"}︡{"done":true}︡
︠73d730fa-f5b3-4486-8123-fb347a60d87cs︠
#Now we have all the secret keys for encryption!

︡dbda7b69-f44f-4a30-863b-314d472d1d58︡{"done":true}︡
︠b3974f9d-f6f8-421d-9fe9-7eed90116ead︠
#Let's unembed M
r=HPSonEC(M2,gpoint_Encryption,G_Encryption,[[2,3],[3,2],[13,1],[17,1],[89,1],[211,1],[839,1],[466637,1],[949777,1]])
r
︡bee6e483-f0cf-4cc1-ab90-622e54f659e3︡{"stdout":"1234\n"}︡{"done":true}︡
︠07e0c44d-6603-44ad-817a-4559172937b1s︠
#Now we have the r they used for encryption, we can use this to find the inverse s's
sA= ECTimes(Apb_Encryption,r,G_Encryption)
sB= ECTimes(Bpb_Encryption,r,G_Encryption)
sC= ECTimes(Cpb_Encryption,r,G_Encryption)
siA=ECInverse(sA,G_Encryption)
siB=ECInverse(sB,G_Encryption)
siC=ECInverse(sC,G_Encryption)
︡181f8c0d-a289-4d2f-9962-3c67bb860043︡{"done":true}︡
︠b5e5a006-bd8e-4a49-bef0-77c6c1126b35s︠
Mt1=ECAdd(siA,M1,G_Encryption)
Mt2=ECAdd(siB,M1,G_Encryption)
Mt3=ECAdd(siC,M1,G_Encryption)
m1=ECUnembed([Mt1],T)
#m2=ECUnembed([Mt2],T)
#m3=ECUnembed([Mt3],T)
m1
#m2
#m3
︡e97537f4-0564-4243-8465-ac04d4a0c737︡{"stdout":"'Tokyo'\n"}︡{"done":true}︡
︠ab5e5fe2-df33-427e-b5a5-f5a640ce6ae2s︠
#m1 was the only one that worked, so Alice must be the recipient
M=ASCIIPad(m1,gorder_Encryption)
M
︡5a66dcfe-4e80-473f-9510-45ffb37e38ea︡{"stdout":"[184211207221211]\n"}︡{"done":true}︡
︠0091917c-639c-4e63-a307-263906d9ceb1s︠
#Let's now check the signature on the message. These are my notes, put here for easy checking
#
#Verification:
#(1) Compute u=y*s^-1 mod q
#(2) Compute v=M*s^-1 mod q
#(3) Compute P=g*V+ (elliptic curve addition) u*b^-1
#Note that P is a point on the elliptic curve E
#P also has coordinates (x_1,y_1)
#The signature is valid if y=x_1 mod q
#Otherwise the signature is NOT valid
#
#So:
U= y*(s^-1) % gorder_Signature
U
z = 184211207221211
V = z*(s^-1) % gorder_Signature
V
p_1=ECTimes(gpoint_Signature,V,G_Signature)
p_2=ECTimes(ECInverse(Cpb_Signature,G_Signature),U,G_Signature)
P=ECAdd(p_1,p_2,G_Signature)
P
p=12093334749287098451036610 % gorder_Signature
p
y
︡cddef8c5-0895-4bfe-a0d4-eb6fc5adedbd︡{"stdout":"364163352104018133215\n"}︡{"stdout":"537581219848672452424\n"}︡{"stdout":"[12093334749287098451036610, 411433098304526179989068]\n"}︡{"stdout":"522228913141586484647\n"}︡{"stdout":"522228913141586484647\n"}︡{"done":true}︡
︠3fb99a93-5753-4419-a60f-8467fc71eeb8s︠
#Because p and y match, we know that Carol sent the message
#Next, we know that r=(M-x*y)/s mod q, so for the random number for the signature, we can:
r_Signature=(z-sx_c*y)*(s^-1) % gorder_Signature
r_Signature
︡efb625dd-777a-424c-82fa-6db3a3d4f0bd︡{"stdout":"432554325\n"}︡{"done":true}︡
︠1692dfb5-1971-4d2f-9fea-568c0fbc2b88s︠
#Now let's check and see if it works, checking it against our given s value and s calculated with our r
#s=(M-x*y)*r^-1 mod q
s
s_check=(z-sx_c*y)*(r_Signature^-1) % gorder_Signature
s_check
︡824d59bf-c22b-4467-8f6b-c7df7afbdb5d︡{"stdout":"496418275430782450147\n"}︡{"stdout":"496418275430782450147\n"}︡{"done":true}︡
︠d4b8f7a1-0983-4f26-b449-68d6807f3ab6s︠
#Because these are the same, we are done.
︡b4d6fb52-f6e5-431a-aad1-d08d9f96da1e︡{"done":true}︡









